// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
//
// End prologue.

#include <cassert>

namespace cli
{
  // usage_para
  //
  inline usage_para::
  usage_para (value v)
  : v_ (v)
  {
  }

  // unknown_mode
  //
  inline unknown_mode::
  unknown_mode (value v)
  : v_ (v)
  {
  }

  // exception
  //
  inline ::std::wostream&
  operator<< (::std::wostream& os, const exception& e)
  {
    e.print (os);
    return os;
  }

  // unknown_option
  //
  inline unknown_option::
  unknown_option (const std::string& option)
  : option_ (option)
  {
  }

  inline const std::string& unknown_option::
  option () const
  {
    return option_;
  }

  // unknown_argument
  //
  inline unknown_argument::
  unknown_argument (const std::string& argument)
  : argument_ (argument)
  {
  }

  inline const std::string& unknown_argument::
  argument () const
  {
    return argument_;
  }

  // missing_value
  //
  inline missing_value::
  missing_value (const std::string& option)
  : option_ (option)
  {
  }

  inline const std::string& missing_value::
  option () const
  {
    return option_;
  }

  // invalid_value
  //
  inline invalid_value::
  invalid_value (const std::string& option,
                 const std::string& value,
                 const std::string& message)
  : option_ (option),
    value_ (value),
    message_ (message)
  {
  }

  inline const std::string& invalid_value::
  option () const
  {
    return option_;
  }

  inline const std::string& invalid_value::
  value () const
  {
    return value_;
  }

  inline const std::string& invalid_value::
  message () const
  {
    return message_;
  }

  // file_io_failure
  //
  inline file_io_failure::
  file_io_failure (const std::string& file)
  : file_ (file)
  {
  }

  inline const std::string& file_io_failure::
  file () const
  {
    return file_;
  }

  // unmatched_quote
  //
  inline unmatched_quote::
  unmatched_quote (const std::string& argument)
  : argument_ (argument)
  {
  }

  inline const std::string& unmatched_quote::
  argument () const
  {
    return argument_;
  }

  // argv_scanner
  //
  inline argv_scanner::
  argv_scanner (int& argc,
                char** argv,
                bool erase,
                std::size_t sp)
  : start_position_ (sp + 1),
    i_ (1),
    argc_ (argc),
    argv_ (argv),
    erase_ (erase)
  {
  }

  inline argv_scanner::
  argv_scanner (int start,
                int& argc,
                char** argv,
                bool erase,
                std::size_t sp)
  : start_position_ (sp + static_cast<std::size_t> (start)),
    i_ (start),
    argc_ (argc),
    argv_ (argv),
    erase_ (erase)
  {
  }

  inline int argv_scanner::
  end () const
  {
    return i_;
  }

  // argv_file_scanner
  //
  inline argv_file_scanner::
  argv_file_scanner (int& argc,
                     char** argv,
                     const std::string& option,
                     bool erase,
                     std::size_t sp)
  : argv_scanner (argc, argv, erase, sp),
    option_ (option),
    options_ (&option_info_),
    options_count_ (1),
    i_ (1),
    skip_ (false)
  {
    option_info_.option = option_.c_str ();
    option_info_.search_func = 0;
  }

  inline argv_file_scanner::
  argv_file_scanner (int start,
                     int& argc,
                     char** argv,
                     const std::string& option,
                     bool erase,
                     std::size_t sp)
  : argv_scanner (start, argc, argv, erase, sp),
    option_ (option),
    options_ (&option_info_),
    options_count_ (1),
    i_ (1),
    skip_ (false)
  {
    option_info_.option = option_.c_str ();
    option_info_.search_func = 0;
  }

  inline argv_file_scanner::
  argv_file_scanner (const std::string& file,
                     const std::string& option,
                     std::size_t sp)
  : argv_scanner (0, zero_argc_, 0, sp),
    option_ (option),
    options_ (&option_info_),
    options_count_ (1),
    i_ (1),
    skip_ (false)
  {
    option_info_.option = option_.c_str ();
    option_info_.search_func = 0;

    load (file);
  }

  inline argv_file_scanner::
  argv_file_scanner (int& argc,
                     char** argv,
                     const option_info* options,
                     std::size_t options_count,
                     bool erase,
                     std::size_t sp)
  : argv_scanner (argc, argv, erase, sp),
    options_ (options),
    options_count_ (options_count),
    i_ (1),
    skip_ (false)
  {
  }

  inline argv_file_scanner::
  argv_file_scanner (int start,
                     int& argc,
                     char** argv,
                     const option_info* options,
                     std::size_t options_count,
                     bool erase,
                     std::size_t sp)
  : argv_scanner (start, argc, argv, erase, sp),
    options_ (options),
    options_count_ (options_count),
    i_ (1),
    skip_ (false)
  {
  }

  inline argv_file_scanner::
  argv_file_scanner (const std::string& file,
                     const option_info* options,
                     std::size_t options_count,
                     std::size_t sp)
  : argv_scanner (0, zero_argc_, 0, sp),
    options_ (options),
    options_count_ (options_count),
    i_ (1),
    skip_ (false)
  {
    load (file);
  }
}

// help_options
//

inline const std::uint64_t& help_options::
build2_metadata () const
{
  return this->build2_metadata_;
}

inline std::uint64_t& help_options::
build2_metadata ()
{
  return this->build2_metadata_;
}

inline void help_options::
build2_metadata (const std::uint64_t& x)
{
  this->build2_metadata_ = x;
}

inline const bool& help_options::
help () const
{
  return this->help_;
}

inline bool& help_options::
help ()
{
  return this->help_;
}

inline void help_options::
help (const bool& x)
{
  this->help_ = x;
}

inline const bool& help_options::
version () const
{
  return this->version_;
}

inline bool& help_options::
version ()
{
  return this->version_;
}

inline void help_options::
version (const bool& x)
{
  this->version_ = x;
}

inline const bool& help_options::
proprietary_license () const
{
  return this->proprietary_license_;
}

inline bool& help_options::
proprietary_license ()
{
  return this->proprietary_license_;
}

inline void help_options::
proprietary_license (const bool& x)
{
  this->proprietary_license_ = x;
}

// options
//

inline const NarrowStrings& options::
disable_warning () const
{
  return this->disable_warning_;
}

inline NarrowStrings& options::
disable_warning ()
{
  return this->disable_warning_;
}

inline void options::
disable_warning (const NarrowStrings& x)
{
  this->disable_warning_ = x;
}

inline const std::string& options::
options_file () const
{
  return this->options_file_;
}

inline std::string& options::
options_file ()
{
  return this->options_file_;
}

inline void options::
options_file (const std::string& x)
{
  this->options_file_ = x;
}

inline const bool& options::
show_sloc () const
{
  return this->show_sloc_;
}

inline bool& options::
show_sloc ()
{
  return this->show_sloc_;
}

inline void options::
show_sloc (const bool& x)
{
  this->show_sloc_ = x;
}

inline const std::size_t& options::
sloc_limit () const
{
  return this->sloc_limit_;
}

inline std::size_t& options::
sloc_limit ()
{
  return this->sloc_limit_;
}

inline void options::
sloc_limit (const std::size_t& x)
{
  this->sloc_limit_ = x;
}

inline const bool& options::
proprietary_license () const
{
  return this->proprietary_license_;
}

inline bool& options::
proprietary_license ()
{
  return this->proprietary_license_;
}

inline void options::
proprietary_license (const bool& x)
{
  this->proprietary_license_ = x;
}

inline const bool& options::
preserve_anonymous () const
{
  return this->preserve_anonymous_;
}

inline bool& options::
preserve_anonymous ()
{
  return this->preserve_anonymous_;
}

inline void options::
preserve_anonymous (const bool& x)
{
  this->preserve_anonymous_ = x;
}

inline const bool& options::
show_anonymous () const
{
  return this->show_anonymous_;
}

inline bool& options::
show_anonymous ()
{
  return this->show_anonymous_;
}

inline void options::
show_anonymous (const bool& x)
{
  this->show_anonymous_ = x;
}

inline const NarrowStrings& options::
anonymous_regex () const
{
  return this->anonymous_regex_;
}

inline NarrowStrings& options::
anonymous_regex ()
{
  return this->anonymous_regex_;
}

inline void options::
anonymous_regex (const NarrowStrings& x)
{
  this->anonymous_regex_ = x;
}

inline const bool& options::
anonymous_regex_trace () const
{
  return this->anonymous_regex_trace_;
}

inline bool& options::
anonymous_regex_trace ()
{
  return this->anonymous_regex_trace_;
}

inline void options::
anonymous_regex_trace (const bool& x)
{
  this->anonymous_regex_trace_ = x;
}

inline const bool& options::
morph_anonymous () const
{
  return this->morph_anonymous_;
}

inline bool& options::
morph_anonymous ()
{
  return this->morph_anonymous_;
}

inline void options::
morph_anonymous (const bool& x)
{
  this->morph_anonymous_ = x;
}

inline const NarrowStrings& options::
location_map () const
{
  return this->location_map_;
}

inline NarrowStrings& options::
location_map ()
{
  return this->location_map_;
}

inline void options::
location_map (const NarrowStrings& x)
{
  this->location_map_ = x;
}

inline const NarrowStrings& options::
location_regex () const
{
  return this->location_regex_;
}

inline NarrowStrings& options::
location_regex ()
{
  return this->location_regex_;
}

inline void options::
location_regex (const NarrowStrings& x)
{
  this->location_regex_ = x;
}

inline const bool& options::
location_regex_trace () const
{
  return this->location_regex_trace_;
}

inline bool& options::
location_regex_trace ()
{
  return this->location_regex_trace_;
}

inline void options::
location_regex_trace (const bool& x)
{
  this->location_regex_trace_ = x;
}

inline const bool& options::
file_per_type () const
{
  return this->file_per_type_;
}

inline bool& options::
file_per_type ()
{
  return this->file_per_type_;
}

inline void options::
file_per_type (const bool& x)
{
  this->file_per_type_ = x;
}

inline const NarrowStrings& options::
type_file_regex () const
{
  return this->type_file_regex_;
}

inline NarrowStrings& options::
type_file_regex ()
{
  return this->type_file_regex_;
}

inline void options::
type_file_regex (const NarrowStrings& x)
{
  this->type_file_regex_ = x;
}

inline const bool& options::
type_file_regex_trace () const
{
  return this->type_file_regex_trace_;
}

inline bool& options::
type_file_regex_trace ()
{
  return this->type_file_regex_trace_;
}

inline void options::
type_file_regex_trace (const bool& x)
{
  this->type_file_regex_trace_ = x;
}

inline const NarrowStrings& options::
schema_file_regex () const
{
  return this->schema_file_regex_;
}

inline NarrowStrings& options::
schema_file_regex ()
{
  return this->schema_file_regex_;
}

inline void options::
schema_file_regex (const NarrowStrings& x)
{
  this->schema_file_regex_ = x;
}

inline const bool& options::
schema_file_regex_trace () const
{
  return this->schema_file_regex_trace_;
}

inline bool& options::
schema_file_regex_trace ()
{
  return this->schema_file_regex_trace_;
}

inline void options::
schema_file_regex_trace (const bool& x)
{
  this->schema_file_regex_trace_ = x;
}

inline const bool& options::
fat_type_file () const
{
  return this->fat_type_file_;
}

inline bool& options::
fat_type_file ()
{
  return this->fat_type_file_;
}

inline void options::
fat_type_file (const bool& x)
{
  this->fat_type_file_ = x;
}

inline const NarrowString& options::
file_list () const
{
  return this->file_list_;
}

inline NarrowString& options::
file_list ()
{
  return this->file_list_;
}

inline void options::
file_list (const NarrowString& x)
{
  this->file_list_ = x;
}

inline const NarrowString& options::
file_list_prologue () const
{
  return this->file_list_prologue_;
}

inline NarrowString& options::
file_list_prologue ()
{
  return this->file_list_prologue_;
}

inline void options::
file_list_prologue (const NarrowString& x)
{
  this->file_list_prologue_ = x;
}

inline const NarrowString& options::
file_list_epilogue () const
{
  return this->file_list_epilogue_;
}

inline NarrowString& options::
file_list_epilogue ()
{
  return this->file_list_epilogue_;
}

inline void options::
file_list_epilogue (const NarrowString& x)
{
  this->file_list_epilogue_ = x;
}

inline const NarrowString& options::
file_list_delim () const
{
  return this->file_list_delim_;
}

inline NarrowString& options::
file_list_delim ()
{
  return this->file_list_delim_;
}

inline void options::
file_list_delim (const NarrowString& x)
{
  this->file_list_delim_ = x;
}

inline const bool& options::
disable_multi_import () const
{
  return this->disable_multi_import_;
}

inline bool& options::
disable_multi_import ()
{
  return this->disable_multi_import_;
}

inline void options::
disable_multi_import (const bool& x)
{
  this->disable_multi_import_ = x;
}

inline const bool& options::
disable_full_check () const
{
  return this->disable_full_check_;
}

inline bool& options::
disable_full_check ()
{
  return this->disable_full_check_;
}

inline void options::
disable_full_check (const bool& x)
{
  this->disable_full_check_ = x;
}

// Begin epilogue.
//
//
// End epilogue.
